#pragma once
#include <FastLED.h>

#define PIXELCOUNT 15


class SmartStrip
{
public:

    void init();

    void reset();

    void setGreen(int led);

    void animateBottomToTop(int r, int g, int b);

    void progressBar(int min, int max, int val);

private:
    CRGB leds[PIXELCOUNT]; // Define the array of leds
    int lastLevel = -1;
};